# 米斯特白帽培训讲义 漏洞篇 弱口令

> 讲师：[gh0stkey](https://www.zhihu.com/people/gh0stkey/answers)

> 整理：[飞龙](https://github.com/)

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)

## 成因

弱口令没有严格和准确的定义，通常认为容易被别人（它们有可能对你很了解）猜测或被破解工具破解的口令均为弱口令。弱口令指的是仅包含简单数字和字母的口令，例如"123"、"abc"等，因为这样的口令很容易被别人破解。

通过爆破工具就可以很容易破解用户的弱口令。

目前网络上也有人特地整理了常用的弱口令（Top 100）：

```
123456 a123456 123456a 5201314 111111 woaini1314 qq123456 123123 000000 1qaz2wsx 1q2w3e4r 
qwe123 7758521 123qwe a123123 123456aa woaini520 woaini 100200 1314520 woaini123 123321 
q123456 123456789 123456789a 5211314 asd123 a123456789 z123456 asd123456 a5201314 aa123456 
zhang123 aptx4869 123123a 1q2w3e4r5t 1qazxsw2 5201314a 1q2w3e aini1314 31415926 q1w2e3r4 
123456qq woaini521 1234qwer a111111 520520 iloveyou abc123 110110 111111a 123456abc w123456 
7758258 123qweasd 159753 qwer1234 a000000 qq123123 zxc123 123654 abc123456 123456q qq5201314 
12345678 000000a 456852 as123456 1314521 112233 521521 qazwsx123 zxc123456 abcd1234 asdasd 
666666 love1314 QAZ123 aaa123 q1w2e3 aaaaaa a123321 123000 11111111 12qwaszx 5845201314 
s123456 nihao123 caonima123 zxcvbnm123 wang123 159357 1A2B3C4D asdasd123 584520 753951 147258 
1123581321 110120 qq1314520
```

## 危害

![](http://ww3.sinaimg.cn/large/841aea59jw1fau41nan6lj20tm0c5dh8.jpg)

中石油的多个加油站的视频监控被入侵，我们可以通过它们看一些隐私。也可以通过它把监控器关掉，来进行一些非法活动。

## 实战

比如说，我们使用这样一段代码来演示弱口令漏洞，它模拟了某个系统的后台。（课件里没有这个代码，这是我还原出来的）

```php
<form method="POST" target="./lesspass.php">
    <input type="text" name="un" />
    <input type="password" name="pw" />
    <input type="submit" value="登录" />
</form>
<?php
$un = @$_POST['un'];
$pw = @$_POST['pw'];
if($un == '' && $pw == '') 
    return;
else if($un == 'admin' && $pw == 'admin888') 
    echo '登录成功';
else
    echo '登录失败';
```

第一行到第六行组成了一个 HTTP 表单。我们可以看到，这个表单使用 POST 方法向这个页面自己提交信息，`un`表单域对应 PHP 的`un`变量，`pw`表单域对应 PHP 的`pw`变量。

第七行和第八行从 HTTP 请求的主体中取出`un`参数和`pw`参数。

第九到第十四行对用户名和密码参数做判断，如果都为空，那么我们认为它仅仅是显示页面的请求，直接返回。如果`un`为`admin`，且`pw`为`admin888`，因为这是我们预设的正确用户名和密码，所以显示登陆成功，否则显示登录失败。

真实代码的用户名和密码是从数据库里面取的，但是它仍然是确定的东西，而且如果存在弱口令，还是能破解出来，原理一致。

把它保存为`lesspass.php`，将其部署后访问`http://localhost/lesspass.php`。

接下来我们假装不知道真实密码，开始尝试。对于管理员账户，用户名一般是`admin`，密码可能为`admin`、`admin123`、`admin888`、`123456`、`123abcadmin`等等。

首先输入`admin`和`admin`，尝试失败：

![](http://ww4.sinaimg.cn/large/841aea59jw1fau41squzzj20eu04zwel.jpg)

之后是`admin`和`admin123`，还是失败。最后尝试`admin`和`admin888`，成功。

![](http://ww1.sinaimg.cn/large/841aea59jw1fau41x5e4hj20f0051glp.jpg)

可见，爆破破解的原理就是一个一个尝试，破解效果完全取决于你所使用的字典。如果密码碰巧在你的字典中，就一定能成功。

当然，有很多用于爆破的工具，比如 Burp，这里就不再演示了。
